# -*- coding: utf-8 -*-


from gensim.models.tfidfmodel import TfidfModel
from gensim import corpora
from math import radians, cos, sin, asin, sqrt
import matplotlib.pyplot as plt
import numpy  as np



topk=50

def distEclud(vec1, vec2):
    if (vec2==0).all():
        return np.array([0])
    dist1 = np.dot(vec1,vec2) / (np.linalg.norm(vec1) * np.linalg.norm(vec2))
    #dist1=1-dist1
    return dist1

def invert_dict(d):
    return dict([(v,k) for (k,v) in d.items()])
 


def load_data(file_name):
    shuju=[]
    f=open(file_name,'r')
    for line in f.readlines():       
        lines=line.strip().split('\t')
        lines[2]=float(lines[2])
        lines[1]=float(lines[1])
        if 39.7500<lines[2]<40.0563 and 116.1500<lines[1]<116.5969:
            shuju.append(lines)
    f.close()
    return shuju 



file=[]
with open("C:\\Users\\hasee\\Desktop\\dbscan\\vocabulary\\14-120.model",'rb') as f:
    for x in f.readlines():
        file.append(x.decode('utf-8'))
                
file=file[1::]
ls={}
typelist=[]
for x in file:
    z=x.strip('\n').split(' ')
    typelist.append(z[0])
    left=np.array(z[1::]).astype(float)
    ls[z[0]]=left

#grid division
shuju=load_data("C:/Users/hasee/Desktop/dbscan/data-res1.txt")
print(len(shuju))
n=4
long=19*n
width=17*n
a = (116.5969-116.1500)/long
b= (40.0563-39.7500)/width

dic={}
for i in range(long):
    for j in range(width):
        f=long*j+i
        dic[f]=[]

texts=[]        
for x in shuju:
    i_id=(x[1]-116.1500)//a
    j_id=(x[2]-39.7500)//b
    f=j_id*long+i_id
    if x[3] in typelist:
        dic[f].append([x[3],ls[x[3]]])
        
     
for k in dic.keys():  
    if dic[k]!=[]:
        zitext=[]
        for m in dic[k]:
            zitext.append(m[0])
        texts.append(zitext)

#tf-idf
dictionary = corpora.Dictionary(texts)
corpus = [dictionary.doc2bow(text) for text in texts]
tf_idf_model = TfidfModel(corpus, normalize=False)
word_tf_tdf = list(tf_idf_model[corpus])
dicid=dictionary.token2id
#print('词典:', dicid)
#print('词频:', corpus)
#print('词的tf-idf值:', word_tf_tdf)
dicid=invert_dict(dicid)
diccount=0
for k in dic.keys():  
    if dic[k]!=[]:    
        media=word_tf_tdf[diccount]
        newls=[]
        for every_word in media:
            newls.append((dicid[every_word[0]],every_word[1]))
        dic[k]=newls
        diccount+=1

    
regionlist=[]
maxx=0
for k in dic.keys():
    number=len(dic[k])
    if dic[k]==[]:
        regionvec=''
        continue
    else:
        #向量平均
        
        totalweight=0
        totalvec=0
        for x in dic[k]:
            totalvec=totalvec+ls[x[0]]*x[1]
            totalweight=totalweight+x[1]
        regionvec=totalvec/totalweight
        
        #向量平均
        if number>maxx:
            maxx=number
        regionlist.append([str(k),str(number),regionvec])






netdic={}
for i in range(long):
    for j in range(width):
        f=long*j+i
        netdic[f]=np.array(0)
for region in regionlist:
    netdic[int(region[0])]=region[2]

Gkernel=[1,2,1,2,4,2,1,2,1]
#Gaussian Kernel
kerneldic=dic.copy()
for j in range(width):
    for i in range(long):
        f=j*long+i
        n=1
        i_id=i
        j_id=j
        kernel=[]
        for j_id in range(j-n,j+n+1):
            for i_id in range(i-n,i+n+1):
                    if  0<=i_id<long and 0<=j_id<width:
                        kernel.append(netdic[j_id*long+i_id])
                    else:
                        kernel.append(np.array(-1))              
        summ=np.array(0)
        for iker in range(9):
            if (kernel[iker]!=-1).all():
                summ=summ+Gkernel[iker]*kernel[iker]
        w=0
        for iker in range(9):
            if (kernel[iker]!=-1).all():
                w=w+Gkernel[iker]
        kerneldic[f]=summ/w

        
        
netdic=kerneldic
    
#query search
siminetdic={}

#query="公司企业;公司;商业贸易"
#query= "商务住宅;住宅区;住宅小区 科教文化服务;学校;高等院校"
#query="餐饮服务;咖啡厅;星巴克咖啡 体育休闲服务;影剧院;电影院"
query= "商务住宅;产业园区;产业园区"
#query= "科教文化服务;学校;高等院校"
#query= "风景名胜;公园广场;公园"
querylist=query.split(' ')
queryv=[]

for vv in querylist:
    for i in typelist:
        if vv in i:
            queryv.append(ls[i])
queryzu=np.vstack(queryv)
if queryzu.shape[0]==1:
    queryvec=queryzu
else:
    queryvec=(np.mean(queryzu,axis=0))
    queryvec.shape=(1,120)
 
#查询       
       
for k in netdic.keys():
    siminetdic[k]=distEclud(queryvec,netdic[k])
    
res=[]    
for j in range(width):
    ls=[]
    for i in range(long):
        fk=long*j+i
        if fk in siminetdic.keys():
            ls.append((siminetdic[fk].tolist())[0])
        else:
            ls.append(0)
    res.append(ls)
res=np.array(res[::-1])


jilu=[]
for i in range(long):
    for j in range(width):
        jilu.append((j,i,res[j][i]))
jilu.sort(reverse=True,key=lambda x:x[2])
zuizhong=jilu[:topk]


for i in range(long):
    for j in range(width):
        res[j][i]=0
  

for v in zuizhong:
    res[v[0]][v[1]]=1



fig=plt.figure(figsize=(12, 9), dpi=100)
plt.imshow(res,cmap=plt.cm.cool)
plt.show()



